package LLI::Route;

# This object should help us keep track of our data better, so we
# don't have to touch the data structures ourselves.
#
# $Id: Route.pm,v 1.1 2003/03/24 01:05:11 mankins Exp $

my $VERSION = 1.00;

use strict;

sub new 
  {
    my $proto = shift;
    my $class = ref($proto) || $proto;

    my ($self) = (@_);

    $self->{'preference'} = $self->{'preference'} || "0";

    bless ($self, $class);
    return $self;
  }

sub jid
  {
    my $self = shift;

    my ($set) = @_;

    if ($set)
      {
	# We want to set the jid to this value.
	return $self->{'jid'} = $set;
      }
    else
      {
	return $self->{'jid'};
      }
  }

sub preference
  {
    my $self = shift;

    my ($set) = @_;

    if ($set)
      {
	# We want to set the preference to this value.
	return $self->{'preference'} = $set;
      }
    else
      {
	return $self->{'preference'};
      }
  }

sub centroid
  {
    my $self = shift;

    my ($set) = @_;

    if ($set)
      {
	# We want to set the centroid to this value.
	return $self->{'centroid'} = $set;
      }
    else
      {
	return $self->{'centroid'};
      }
  }

sub centroid_lat
  {
    my $self = shift;

    my ($set) = @_;

    if ($set)
      {
	# We want to set the centroid lat to this value.
	return $self->{'centroid'}->{'lat'} = $set;
      }
    else
      {
	return $self->{'centroid'}->{'lat'};
      }
  }

sub centroid_lon
  {
    my $self = shift;

    my ($set) = @_;

    if ($set)
      {
	# We want to set the centroid lon to this value.
	return $self->{'centroid'}->{'lon'} = $set;
      }
    else
      {
	return $self->{'centroid'}->{'lon'};
      }
  }

sub boundary
  {
    my $self = shift;

    my ($set) = @_;

    if ($set)
      {
	# We want to set the boundary to this value.
	return $self->{'boundary'} = $set;
      }
    else
      {
	return $self->{'boundary'};
      }
  }

sub boundary_top
  {
    my $self = shift;

    my ($type, $set) = @_;

    if ($set)
      {
	# We want to set the boundary to this value.
	return $self->{'boundary'}->{'top'}->{$type} = $set;
      }
    else
      {
	return $self->{'boundary'}->{'top'}->{$type};
      }
  }

sub boundary_bottom
  {
    my $self = shift;

    my ($type, $set) = @_;

    if ($set)
      {
	# We want to set the boundary to this value.
	return $self->{'boundary'}->{'bottom'}->{$type} = $set;
      }
    else
      {
	return $self->{'boundary'}->{'bottom'}->{$type};
      }
  }

1;
